
class cardinalSpline extends genericSplineCurve {
		
	double rho;
	
	
	public cardinalSpline() {
		
		super();
		nbPointsToCopyToCloseCurve = 3;	
		rho = 0.5;
	}
	
	public void decreaseRho() {
		
		rho-=0.1;
		reCompute = true;
		
	}

	public void increaseRho() {
		
		rho+=0.1;
		reCompute = true;
				
	}

	public void computeSplineCurve() {

		double x,y,t;
		double p[][] = new double[4][2];
		double d[] = new double[4];
		double h[] = new double[4];

		intermediatePoints.removeAllElements();
		intermediatePoints.trimToSize();
		nbPoints=0;
			
		if (nbControlPoints>=4) {
			for(int j=0;j<nbControlPoints-3;j++)  {
				for(int k=j;k<j+4;k++) {
					p[k-j][0] = (int)(((coord2D)(controlPoints.elementAt(k))).x);
	    		p[k-j][1] = (int)(((coord2D)(controlPoints.elementAt(k))).y);			   					
				}
				for(int i=0;i<=nbPointsPerSegment;i++) {				
					t = (double)i/(double)nbPointsPerSegment;		
					h[0] = t-2*t*t+t*t*t;
					h[1] = 1-3*t*t+2*t*t*t;
					h[2] = 3*t*t-2*t*t*t;
					h[3] = -t*t+t*t*t;
					d[0] = -rho*h[0];
					d[3] = rho*h[3];
					d[1] = h[1]-d[3];
					d[2] = h[2]-d[0];
					x = d[0]*p[0][0]+d[1]*p[1][0]+d[2]*p[2][0]+d[3]*p[3][0];	
					y = d[0]*p[0][1]+d[1]*p[1][1]+d[2]*p[2][1]+d[3]*p[3][1];	
					intermediatePoints.addElement(new coord2D(x,y));
					nbPoints++;
				}
			}
		}
			
	}
	
	
}