import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.lang.*;

public class splineCalculator extends Applet implements KeyListener, MouseListener, MouseMotionListener {
	
	
	private genericSplineCurve splines[];
	private Polygon pol;
	private Vector vec;
	private int x,y;
	private int nbSplines;
	
/**************************/	
/* Gestion des evenements */
/**************************/
	
	
	public void keyPressed(KeyEvent e) {
		//System.out.println("keyPressed");
	}
	
	
	public void keyReleased(KeyEvent e) {
		//System.out.println("keyReleased");
	}
	
	
	public void keyTyped(KeyEvent e) {
		
		//System.out.println("keyTyped");
		
		if (e.getKeyChar()=='o')
			for(int i=0;i<nbSplines;i++)
				splines[i].closed(false);
		else if (e.getKeyChar()=='c')
			for(int i=0;i<nbSplines;i++)
				splines[i].closed(true);
		else if (e.getKeyChar()=='r')
			for(int i=0;i<nbSplines;i++)
				splines[i].reset();	
		else if (e.getKeyChar()=='+')
			for(int i=0;i<nbSplines;i++)
				splines[i].increasePrecision();
		else if (e.getKeyChar()=='-')
			for(int i=0;i<nbSplines;i++)
				splines[i].decreasePrecision();
		else if (e.getKeyChar() == 'a')
			((cardinalSpline)splines[1]).increaseRho();      
		else if (e.getKeyChar() == 'z')
			((cardinalSpline)splines[1]).decreaseRho();
    		else if (e.getKeyChar() == 's')
			for(int i=0;i<nbSplines;i++)
				splines[i].smoothForBezierCurve();

		repaint();
		
	}
	
	
	public void mouseClicked(MouseEvent e) {
		
		//System.out.println("mouseClicked");
		
		if ((e.getModifiers() & InputEvent.BUTTON1_MASK)!=0) {
			for(int i=0;i<nbSplines;i++)
				if (splines[i].getNumSelectedControlPoint()==-1)
					splines[i].addControlPoint((double)e.getX(),(double)e.getY());
				else
					splines[i].moveSelectedControlPoint((double)e.getX(),(double)e.getY());
		}
		else if ((e.getModifiers() & InputEvent.BUTTON3_MASK)!=0) 
			for(int i=0;i<nbSplines;i++)
				splines[i].selectCloserControlPoint(e.getX(),e.getY(),3);
		else if ((e.getModifiers() & InputEvent.BUTTON2_MASK)!=0) 
			for(int i=0;i<nbSplines;i++)
				splines[i].removeSelectedControlPoint();

		repaint();
		
	}
	
	
	public void mouseDragged(MouseEvent e) {
		
		//System.out.println("mouseDragged");
		
		for(int i=0;i<nbSplines;i++)
			if (splines[i].getNumSelectedControlPoint()!=-1)
					splines[i].moveSelectedControlPoint((double)e.getX(),(double)e.getY());

		repaint();
				
	}
	
	
	public void mouseEntered(MouseEvent e) {
		//System.out.println("mouseEntered");
	}
	
	
	public void mouseExited(MouseEvent e) {
		//System.out.println("mouseExited");
	}

	
	public void mouseMoved(MouseEvent e) {
		//System.out.println("mouseMoved");
	}

	
	public void mousePressed(MouseEvent e) {
		//System.out.println("mousePressed");
	}
	

	public void mouseReleased(MouseEvent e) {
		//System.out.println("mouseReleased");
	}
	

/***********************/
/* Gestion de l'applet */
/***********************/
	
	public void init() {
		
		super.init();
		setName("Courbes de Spline");
		setLayout(null);
		setSize(800, 600);		
		setBackground(Color.black);
	
		nbSplines = 3;
		
		splines = new genericSplineCurve[nbSplines];
		
		splines[0] = new bezierSpline();
		splines[1] = new cardinalSpline();
		splines[2] = new cubicUniformBSpline();		
		
		addMouseListener(this);
		addMouseMotionListener(this);
		addKeyListener(this);		

	}

	
	public void paint(Graphics g) {
		
		super.paint(g);	

		g.clearRect(0,0,800,600);
		
		g.setColor(Color.cyan);				
		vec = splines[0].getControlPoints();
		for(int i=0;i<vec.size();i++) {
	    x = (int)(((coord2D)(vec.elementAt(i))).x);
	  	y = (int)(((coord2D)(vec.elementAt(i))).y);
	    g.drawRect(x-2,y-2,4,4);
		}
		
		g.setColor(Color.gray);						
		g.drawPolyline(splines[0].getControlLineX(),splines[0].getControlLineY(),splines[0].getNbControlPoints());

		int j = splines[0].getNumSelectedControlPoint();
		g.setColor(Color.white);	
		if (j!=-1)
			g.drawOval((int)(((coord2D)(vec.elementAt(j))).x)-8,(int)(((coord2D)(vec.elementAt(j))).y)-8,16,16);
		
		for(int i=0;i<nbSplines;i++){
			if (i==0)
				g.setColor(Color.yellow);						
			else if (i==1)
				g.setColor(Color.blue);						
			else if (i==2)
				g.setColor(Color.red);						
			
			g.drawPolyline(splines[i].getSplineCurveX(),splines[i].getSplineCurveY(),splines[i].getNbCurvePoints());		
			
		}
		
	}
	
	
	public static void main(java.lang.String[] args) {

		splineCalculator aSplineCalculator = new splineCalculator();

	}

}

